/********************************************************************
 * cc.h         20-FEB-1992            Y.Takeuchi (T.I.T.)          *
 *                                                                  *
 * original: cc.h on SUN4 by Y.Yasu (KEK)                           *
 * for SUN-SPARC SF-VME K2917 K3922                                 *
 *                                                                  *
 * 13-JUL-1992 Y.Takeuchi    modified for new CC-driver             *
 * 30-NOV-1992 Y.Takeuchi    modified                               *
 *  5-MAR-1993 Y.Takeuchi    modify for unified UNIX camlib         *
 ********************************************************************/
#include <sys/types.h>
#include <sys/ioccom.h>

#define CC_START_MESSAGE \
    "CAMAC device driver V1.22d, 1991-1993 by Y.TAKEUCHI (T.I.T.)\n"

#define NCC 1  

#define CC_MINPHYS_SIZE 0x10000        /* max word count = 64k */
#define CC_K_MAX_BRANCH 1              /* fixed at 1 (current version) */
#define MAX_CRATE       8              /* number of K3922's address */

/* command for message structure */
#define CC_CMD_DOSINGLE         1
#define CC_CMD_DOBLOCK          2
#define CC_CMD_LOADLIST         3
#define CC_CMD_LOADDOLIST       4
#define CC_CMD_DOLIST           5
#define CC_CMD_ADDKLIST         6
#define CC_CMD_DELKLIST         7
#define CC_CMD_EXEKLIST         8
#define CC_CMD_SAVEKLIST        9
#define CC_CMD_LOADKLIST       10

/* ioctl command */
#define CCIOC_CHK_BRANCH        _IOR(c,0,int) /* check branch # */
#define CCIOC_SET_BRANCH        _IOW(c,1,int) /* set branch # */
#define CCIOC_SET_CRATE         _IOW(c,2,int) /* set crate # */
#define CCIOC_WAIT_LAM          _IOW(c,3,int) /* wait LAM interrupt */
#define CCIOC_ENABLE_LAM        _IOW(c,4,int) /* enable LAM interrupt */
#define CCIOC_DISABLE_LAM       _IOW(c,5,int) /* disable LAM interrupt */
#define CCIOC_REG_DUMP          _IOR(c,6,struct K_REG)
#define CCIOC_RESET             _IOW(c,7,int)
#define CCIOC_READ_STATUS       _IOR(c,8,int)
#define CCIOC_KINIT             _IOW(c,9,int)

/* interrupt source (for cc->interrupt) */
#define CC_INT_LAM		1
#define CC_INT_DONE		2
#define CC_INT_EMPTY		4
#define CC_INT_ABORT		8
#define CC_INT_TIMEOUT    	0x8000

/* for kinetic list processing */
#define CC_KLIST_YES            1
#define CC_KLIST_NO             0
#define CC_KLIST_CMAINIT        100     /* beginning of kinetic lists */

#define CC_BUSY                 1       /* for cc->busy */


struct cc_message {
    u_short command;
    u_short mode;
    u_short naf;
    u_short *ptr_data;
    u_short *ptr_qx;
    struct cc_iosb *ptr_iosb;
    char *klname;
};


