/********************************************************************
 * camt6.c       20-FEB-1992             Y.Takeuchi                 *
 *                                                                  *
 * K2917 list processing test program                               *
 *	camt6 [loop_count]                                          *
 ********************************************************************/
#include    <stdio.h>
#include    <string.h>
#include    "camtest.h"
#include    "camlib.h"

#define D_size     20240
#define L_size     1024
#define DEFLOP    10

main(argc, argv)
int argc;
char *argv[];
{
    int nafct, nafrt, nafw, nafr, nafn, q, x, time;
    int dumy, dat0, dat1;
    unsigned short list[L_size];
    int data[D_size];
    unsigned short *datas = (unsigned short *)data;
    struct cc_iosb iosb;
    register int status, loop;
    int i, lenlis;

/* Read options */
    loop = (argc > 1) ? atoi(argv[1]) : DEFLOP;

/* Initialize */
/* Initialize valiable */
    nafct = NAF(CAMAC_SCALER, 1, 9);
    nafrt = NAF(CAMAC_SCALER, 1, 0);
    nafw = NAF(CAMAC_SWITCH, 0, 16);
    nafr = NAF(CAMAC_SWITCH, 0, 0);
    nafn = NAF(CAMAC_SWITCH, 0, 26);

/* Open */
    if (CAMOPN()) {
	printf("Open error!\n");
        exit(1);
    }
    CGENC();
    CGENZ();
    CREMI();
    CKINIT();

/* read & install camac list 1 */
    if (CRLIST("camt61.obj", list, L_size, &lenlis, &i)) {
	printf("Read list error!\n");
        exit(2);
    }
/*    printf(" list length = %d\n", lenlis); */
    if (CKADD("offset", list, lenlis)) {
	printf("Load list error!\n");
        exit(3);
    }

/* read & install camac list 2 */
    if (CRLIST("camt62.obj", list, L_size, &lenlis, &i)) {
	printf("Read list error!\n");
        exit(2);
    }
/*    printf(" list length = %d\n", lenlis); */
    if (CKADD("measure", list, lenlis)) {
	printf("Load list error!\n");
        exit(3);
    }

/* 16bit time=0 */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++) {
	CAMACW(nafct, &dumy, &q, &x);
	CAMACW(nafrt, &dat0, &q, &x);
	CAMACW(nafrt, &dat1, &q, &x);
	printf("%d\n", dat1 - dat0);
    }

/* offset */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++) {
	CAMACW(nafct, &dumy, &q, &x);
	CAMACW(nafrt, &dat0, &q, &x);
	CKEXEC("offset", data, D_size, &iosb);
	CAMACW(nafrt, &dat1, &q, &x);
	printf("%d\n", dat1 - dat0);
    }

/* measure */
    CKEXEC("measure", data, D_size, &iosb);

loop = 50;

/* 24bit time=0 & read */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", data[1+i+1] - data[1+i]);

/* 24bit write */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", data[2+loop*1+i+1] - data[2+loop*1+i]);

    datas = (unsigned short *)&data[3+loop*2];

/* 16bit time=0 & read */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", datas[i+1] - datas[i]);

/* 16bit write */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", datas[1+loop*1+i+1] - datas[1+loop*1+i]);

/* 16bit ndt */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", datas[2+loop*2+i+1] - datas[2+loop*2+i]);

/* Dump buffer */
/*
    for(i = 0; i < 200; i++)
      printf("data[%3d]=0x%8x %10u  usp[%3d]=0x%4x %5d  usp[%3d]=0x%4x %5d\n",
	     i, data[i], data[i], i*2, datas[i*2], datas[i*2],
	     i*2+1, datas[i*2+1], datas[i*2+1]);
    printf("\n");
*/

/* save to file */
    CKSAVE("camt6.klist");

/* Close */
    CAMCLS();

    return 0;
}
